﻿# include <Siv3D.hpp> // OpenSiv3D v0.6.6
using App = SceneManager<String>;

class Opening : public App::Scene
{
private:
	const Audio click{ Resource(U"example/Accent32-1.mp3") };
	const Font fontMSDF{ FontMethod::MSDF,50 };
	Rect Rect1{ 440, 450, 300, 60 };
public:
	Opening(const InitData& init)
		: IScene{ init }
	{

	}

	void update() override
	{
		if (MouseL.down()) {
			click.playOneShot();
		if ((Cursor::Pos().x >= 440 && Cursor::Pos().x < 740) && (Cursor::Pos().y >= 450 && Cursor::Pos().y < 510))changeScene(U"Game");
		}
		}

	void draw() const override
	{
		FontAsset(Resource(U"TitleFont"))(U"四字熟語ゲーム").drawAt(600, 80, Palette::Black);
		Rect1.draw();
		fontMSDF(U"スタート").draw(490, 443, Palette::Black);

	}
};

class Game : public App::Scene
{
	int Mode = 0;
	const Audio quiz{ Resource(U"example/Quiz-Question03-1.mp3") };
	const Audio correct{ Resource(U"example/Quiz-Correct_Answer02-2.mp3") };
	const Audio incorrect{ Resource(U"example/Quiz-Wrong_Buzzer02-1.mp3") };
private:
	const Texture cry{ Resource(U"example/businessman_cry_man.png") };
	const Texture led{ Resource(U"example/12979.png") };
	const Texture paper{ Resource(U"example/cooking_kitchen_paper.png") };
	const Font fontMSDF{ FontMethod::MSDF,45 };
	Rect Rect1{ 440, 450, 300, 60 };
public:
	Game(const InitData& init)
		: IScene{ init }
	{
		quiz.play();
	}

	void update() override
	{
		
		if (SimpleGUI::Button(U"店", Vec2{ 400, 500 }))
		{
			incorrect.playOneShot();
			Mode = 1;
		}
		if (SimpleGUI::Button(U"点", Vec2{ 500, 500 }))
		{
			incorrect.playOneShot();
			Mode = 1;
		}
		if (SimpleGUI::Button(U"天", Vec2{ 600, 500 }))
		{
			incorrect.playOneShot();
			Mode = 1;
		}
		if (SimpleGUI::Button(U"転", Vec2{ 700, 500 }))
		{
			correct.playOneShot();
			Mode = 2;
		}
		/*if (SimpleGUI::Button(U"タイトルへ戻る", Vec2{700, 700}))
		{
			changeScene(U"Opening");
		}*/
		if (Mode == 1) {
			cry.scaled(1.34).draw(350, 450);
			paper.scaled(0.16).draw(570, 640);
		}
		if (Mode == 2) {
			led.scaled(1.34).draw(280, 130);
			
		}
	}

	void draw() const override
	{
		
		FontAsset(Resource(U"TitleFont"))(U"本末○倒").drawAt(600, 120, Palette::Black);
		fontMSDF(U"○の中に入る言葉は？？").draw(380, 300, Palette::Black);

	}
};



void Main()
{
	int FPS = 60; // 1秒間に1画面を書き換える回数
	Stopwatch sw; //60FPS
	sw.start(); //60FPS
	Scene::SetResizeMode(ResizeMode::Keep);
	Scene::Resize(1200, 800);
	Window::SetTitle(U"四字熟語ゲーム");
	Window::Resize(1200, 800); //ウィンドウサイズ
	Window::SetStyle(WindowStyle::Sizable); //ウィンドウを可変
	// 背景の色を設定 | Set background color
	Scene::SetBackground(ColorF{ 0.8, 0.9, 1.0 });
	FontAsset::Register(Resource(U"TitleFont"), 60, Typeface::Heavy);
	// 通常のフォントを作成 | Create a new font
	const Font font{ 60 };


	// シーンマネージャーを作成
	App manager;

	//オープニング画面
	manager.add<Opening>(U"Opening");
	manager.add<Game>(U"Game");
	while (System::Update())
	{
		//ClearPrint();
		/*if (MouseL.down()) {
			Print << Cursor::Pos();
		}*/
		if (not manager.update())
		{
			break;
		}
		while (sw.msF() < 1000.0 / FPS);
		sw.restart();
	}
}
